package org.netkernel.wiki.rm.endpoint;

import java.util.LinkedList;

import name.fraser.neil.plaintext.diff_match_patch;
import name.fraser.neil.plaintext.diff_match_patch.Diff;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class DiffEndpoint extends StandardAccessorImpl
{
	public DiffEndpoint()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{	String wikiURI=aContext.getThisRequest().getArgumentValue("operand");	
		String v1=aContext.getThisRequest().getArgumentValue("v1").substring(2);
		String v2=aContext.getThisRequest().getArgumentValue("v2").substring(2);
		String v1r=(String)aContext.source(wikiURI+"."+v1, String.class);
		String v2r=(String)aContext.source(wikiURI+"."+v2, String.class);
		
		diff_match_patch dmp=new diff_match_patch();
		 LinkedList<Diff> diffs=dmp.diff_main(v1r,v2r, true);
		 dmp.diff_cleanupSemantic(diffs);
		 StringBuilder b=new StringBuilder(1024);
		 b.append("<div>");
		 b.append(dmp.diff_prettyHtml(diffs));
		 b.append("</div>");
		INKFResponse resp=aContext.createResponseFrom(b.toString());
		resp.setMimeType("text/html");
	}	
}
