package org.netkernel.wiki.rm.endpoint;

import java.io.StringReader;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.util.XMLUtils;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class JavaRenderEngine extends StandardAccessorImpl
{
	public final static String ESCAPE_CDATA_IN_CDATA_FROM="\\]\\]>";
	public final static String ESCAPE_CDATA_IN_CDATA_TO="\\]\\]\\]\\]><!\\[CDATA\\[>";
	
	public JavaRenderEngine()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{	String type=aContext.getThisRequest().getArgumentValue("activeType");
		String opd=(String)aContext.source("arg:operand", String.class);
		if(type.endsWith("XHTML"))
		{	aContext.createResponseFrom(Java2XHTML.convert(new StringReader(opd)));
		}
		else
		{	//Docbook
			aContext.createResponseFrom("<programlisting><![CDATA["+opd.replaceAll(ESCAPE_CDATA_IN_CDATA_FROM, ESCAPE_CDATA_IN_CDATA_TO )+"]]></programlisting>");
		}
	}
}
