package org.netkernel.wiki.rm.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class RelativeSVGEngine extends StandardAccessorImpl
    {

    public RelativeSVGEngine()
        {
        this.declareThreadSafe();
        }

    @Override
    public void onSource(INKFRequestContext aContext) throws Exception
        {
        StringBuilder sb = new StringBuilder(32768);

        String type = aContext.getThisRequest().getArgumentValue("activeType");
        String operandURI = aContext.source("arg:operand", String.class);
        String operand = aContext.source(operandURI, String.class);
        Object result;

        if (type.endsWith("XHTML"))
            {
            //sb.append("<div class=\"svg\"><script type=\"image/svg+xml\">"); //<script type=\"image/svg+xml\">
            sb.append(operand.substring(operand.indexOf("<svg")));
            //sb.append("</script></div>");
            result = sb.toString();
            }
        else if(type.endsWith("DOCBOOK"))
            {
            sb.append("<mediaobject><imageobject>");
            sb.append(operand.substring(operand.indexOf("<svg")));
            sb.append("</imageobject></mediaobject>");
            result = sb.toString();
            }
        else
            {
            throw new NKFException("Unknown document type requested.");
            }
        aContext.createResponseFrom(result);
        }
    }
