package org.netkernel.wiki.rm.endpoint;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class XMLRenderEngine extends StandardAccessorImpl
{
	public XMLRenderEngine()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{	String type=aContext.getThisRequest().getArgumentValue("activeType");
		Object result=null;
		if(type.endsWith("XHTML"))
		{	INKFRequest req=aContext.createRequest("active:xsltc");
			req.addArgument("operand", "arg:operand");
			req.addArgument("operator", "res:/org/netkernel/wiki/rm/endpoint/xmlverbatim.xsl");
			req.setRepresentationClass(String.class);
			result=aContext.issueRequest(req);
		}
		else
		{	//Docbook
			String opd=(String)aContext.source("arg:operand", String.class);
			result="<programlisting><![CDATA["+opd.replaceAll(JavaRenderEngine.ESCAPE_CDATA_IN_CDATA_FROM, JavaRenderEngine.ESCAPE_CDATA_IN_CDATA_TO )+"]]></programlisting>";		
		}
		aContext.createResponseFrom(result);
	}
}
