var pdf=false;
var slinkiShowSplashDuration=3000;
var screencss="";
var pdfcss="";

function boot(){
	offset();
	if(slinki.error)
	{	alert("Problem parsing {slinki} JSON\n"+slinki.json);
	}
	setTitle();
	setCopyright();
	setFavicon();
	setScripts();
	setCSS();
	
	
	var splash=$("#splash").detach();
	
	//Take care of the vertical slides first
	$(".vslide").each(function() {
		var vsections=$(this).find(".slide").detach();
		$(this).children().remove();
		$(this).append(vsections);
	}
	);
	
	//Now take care of all slides
	var slides=$(".slide:not(section>section)").detach();	//Leave any vertical sections in-situ but grab all root sections
	$("body").children().remove();
		
	//Put the slides back
	$("body").append("<div class='reveal'><div id='insertSlides' class='slides'> </div></div><div id='revealBoot'></div>");
	slides.appendTo("#insertSlides");
	
	//Put the splash back
	$("body").append(splash);
	
	//Boot Reveal
	$("#revealBoot").html("<script src='/wink/res/revealImpl/1.1.1/lib/js/head.min.js'>_</script><script src='/wink/res/revealImpl/1.1.1/js/reveal.js'>_</script><script>initReveal();</script>");
	
	//Show Splash if not self referenced
	transition=document.URL;
	if(transition.indexOf("?transition") < 0)
	{	showSplash();
	}
	
	setVertical();
	bindTogglePrintPDF();
	
	
}

function showSplash()
{	if(slinki.splashDuration!=null)
	{	slinkiShowSplashDuration=slinki.splashDuration;
	}
	show=$("#splash").length==1;
	if(show && slinkiShowSplashDuration>0)
	{
		$(".slide, .background").css({ "opacity" : 0.25 } );
	 	$("#splash").css({"opacity" : 1, "display": "block", "visibility" : "visible" , "position":"fixed", "top": "25%" , "left": "25%", "width": "50%", "height":"50%" , "z-index":"1000"} ); 
	 	$("#splash").click(function()
	 		{	hideSplash(0);
	 			return false;
	 		}	
	 	);
	 	setTimeout('hideSplash(500)', slinkiShowSplashDuration);
 	}
}
 
function hideSplash(t)
{	$("#splash").fadeOut(t);
	$(".slide, .background").css({ "opacity" : 1.0 } );
	//remove splash so it doesn't appear in printout
	$("#splash").remove();
	
}
 
function setVertical()
{	h=$(window).height();
	h=h*0.65;
	$(".vframe").css({"height":h});
}

function bindTogglePrintPDF()
{	$("body").keydown(function(evt){
			if(evt.which==65)
			{	if(!pdf)
				{	$("head link[href='"+screencss+"']").attr("href", pdfcss);
					$(".vframe").css({"height": "400px"});
				}
				else
				{	$("head link[href='"+pdfcss+"']").attr("href", screencss);
					setVertical();
				}
				pdf=!pdf;
			}
		}
	);
}

//SliNKi Initialisation
function setTitle()
{	title=slinki.title;
	try
	{	if(title==null)
		{	header=$("h1:first");
			if(header==null)
			{	header=$("h2:first");
			}
			if(header==null)
			{	header=$("h3:first");
			}
			if(header==null)
			{	header=$("p:first");
			}
			title="SliNKi : "+header.text();
		}
	}
	catch(e)
	{	title="SliNKi Presentation";
	}
	$("title").html(title);
}
function setCopyright()
{	copyright=slinki.copyright;
	if(copyright!=null)
	{	$("head meta[name='copyright']").attr("content", copyright);
	}
}
function setFavicon()
{	favicon=slinki.favicon;
	if(favicon!=null)
	{	$("#favicon").attr("href", favicon);
	}
	//Force browsers to see that favicon has changed!
	favicon=$("#favicon").detach();
	$("head").append(favicon);
}
function setScripts()
{	if(slinki.scripts!=null)
	{	for(i=0; i<slinki.scripts.length; i++)
		{	s=slinki.scripts[i];
			$("head").append("<script src='"+s+"' type='text/javascript'>_</script>");
		}
	}
}
function setCSS()
{	var css=slinki.css;
	if(css==null)
	{	//Default CSS
		css= [
				{ "href" : "/wink/res/revealImpl/1.1.1/css/print/print.css", "media" : "print" },
				{ "href" : "/wink/res/revealImpl/1.1.1/css/reveal.css" },
				{ "href" : "/wink/res/revealImpl/1.1.1/css/theme/1060.css" },
				{ "href" : "/wink/res/revealImpl/1.1.1/css/print/screen.css", "screen" : true },
				{ "href" : "/wink/res/revealImpl/1.1.1/css/print/pdf.css", "pdf" : true },
				{ "href" : "/wink/res/revealImpl/1.1.1/lib/css/magula.css" },
				{ "href" : "/wink/style/xmlverb.css" }
			];
	}
	for(i=0; i<css.length; i++)
	{	s=css[i];
		href=s.href;
		media=s.media;
		if(media==null)
		{	set=true;
			if(s.screen)
			{	screencss=s.href;
			}
			if(s.pdf)
			{	pdfcss=s.href;
				set=false;
			}
			if(set)
			{	$("head").append("<link href='"+s.href+"' rel='stylesheet' type='text/css' />");
			}
		}
		else
		{	$("head").append("<link href='"+s.href+"' rel='stylesheet' type='text/css' media='"+media+"'/>");
		}
	}
}
function initReveal()
{	var reveal=slinki.reveal;
	if(reveal==null)
	{	//Defaults
		reveal={
	    // Display controls in the bottom right corner
	    controls: false,
	    // Display a presentation progress bar
	    progress: true,
	    // Push each slide change to the browser history
	    history: false,
	    // Enable keyboard shortcuts for navigation
	    keyboard: true,
	    // Enable the slide overview mode
	    overview: true,
	    // Vertical centering of slides
	    center: false,
	    // Loop the presentation
	    loop: false,
	    // Change the presentation direction to be RTL
	    rtl: false,
	    // Number of milliseconds between automatically proceeding to the 
	    // next slide, disabled when set to 0, this value can be overwritten
	    // by using a data-autoslide attribute on your slides
	    autoSlide: 0,
	    // Enable slide navigation via mouse wheel
	    mouseWheel: false,
	    // Apply a 3D roll to links on hover
	    rollingLinks: false,
	    // Transition style
	    transition: 'linear', // default/cube/page/concave/zoom/linear/fade/none
	    dependencies: [
	        // Cross-browser shim that fully implements classList - https://github.com/eligrey/classList.js/
	        { src: '/wink/res/revealImpl/1.1.1/lib/js/classList.js', condition: function() { return !document.body.classList; } },
	        // Interpret Markdown in <section> elements
	        { src: '/wink/res/revealImpl/1.1.1/plugin/markdown/showdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
	        { src: '/wink/res/revealImpl/1.1.1/plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
	        // Syntax highlight for <code> elements
	        { src: '/wink/res/revealImpl/1.1.1/plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
	        // Zoom in and out with Alt+click
	        { src: '/wink/res/revealImpl/1.1.1/plugin/zoom-js/zoom.js', async: true, condition: function() { return !!document.body.classList; } }
	    ]
		};
	}
	Reveal.initialize(reveal);
	//Fix highlight js by delaying
	setTimeout('highlightCode();', 2000);
}
function highlightCode()
{	try
	{	$('code').each(function(i, e) { hljs.highlightBlock(e); });
	}
	catch(e){};
}
function offset()
{	url=document.URL
	param=url.indexOf("?");
	hash=url.indexOf("#");
	if(param<0 && hash>0)
	{	url=url.substring(hash+1);
		page=parseInt(url);
		if( !isNaN(page) )
		{	page--;
			window.location.href="?transition=linear#/"+page;
			return;
		}
	}
}